from strictyaml.ruamel.error import *
from strictyaml.ruamel.nodes import *
from _typeshed import Incomplete
from typing import Any, Dict, Optional

class RepresenterError(YAMLError): ...

class BaseRepresenter:
    yaml_representers: Dict[Any, Any]
    yaml_multi_representers: Dict[Any, Any]
    dumper: Incomplete
    default_style: Incomplete
    default_flow_style: Incomplete
    represented_objects: Incomplete
    object_keeper: Incomplete
    alias_key: Incomplete
    sort_base_mapping_type_on_output: bool
    def __init__(
        self, default_style: Any = ..., default_flow_style: Any = ..., dumper: Any = ...
    ) -> None: ...
    @property
    def serializer(self) -> Any: ...
    def represent(self, data: Any) -> None: ...
    def represent_data(self, data: Any) -> Any: ...
    def represent_key(self, data: Any) -> Any: ...
    @classmethod
    def add_representer(cls, data_type: Any, representer: Any) -> None: ...
    @classmethod
    def add_multi_representer(cls, data_type: Any, representer: Any) -> None: ...
    def represent_scalar(
        self, tag: Any, value: Any, style: Any = ..., anchor: Any = ...
    ) -> Any: ...
    def represent_sequence(
        self, tag: Any, sequence: Any, flow_style: Any = ...
    ) -> Any: ...
    def represent_omap(self, tag: Any, omap: Any, flow_style: Any = ...) -> Any: ...
    def represent_mapping(
        self, tag: Any, mapping: Any, flow_style: Any = ...
    ) -> Any: ...
    def ignore_aliases(self, data: Any) -> bool: ...

class SafeRepresenter(BaseRepresenter):
    def ignore_aliases(self, data: Any) -> bool: ...
    def represent_none(self, data: Any) -> Any: ...
    def represent_str(self, data: Any) -> Any: ...
    def represent_binary(self, data: Any) -> Any: ...
    def represent_bool(self, data: Any, anchor: Optional[Any] = ...) -> Any: ...
    def represent_int(self, data: Any) -> Any: ...
    inf_value: float
    def represent_float(self, data: Any) -> Any: ...
    def represent_list(self, data: Any) -> Any: ...
    def represent_dict(self, data: Any) -> Any: ...
    def represent_ordereddict(self, data: Any) -> Any: ...
    def represent_set(self, data: Any) -> Any: ...
    def represent_date(self, data: Any) -> Any: ...
    def represent_datetime(self, data: Any) -> Any: ...
    def represent_yaml_object(
        self, tag: Any, data: Any, cls: Any, flow_style: Any = ...
    ) -> Any: ...
    def represent_undefined(self, data: Any) -> None: ...

class Representer(SafeRepresenter):
    def represent_complex(self, data: Any) -> Any: ...
    def represent_tuple(self, data: Any) -> Any: ...
    def represent_name(self, data: Any) -> Any: ...
    def represent_module(self, data: Any) -> Any: ...
    def represent_object(self, data: Any) -> Any: ...

class RoundTripRepresenter(SafeRepresenter):
    def __init__(
        self, default_style: Any = ..., default_flow_style: Any = ..., dumper: Any = ...
    ) -> None: ...
    def ignore_aliases(self, data: Any) -> bool: ...
    def represent_none(self, data: Any) -> Any: ...
    def represent_literal_scalarstring(self, data: Any) -> Any: ...
    represent_preserved_scalarstring = represent_literal_scalarstring
    def represent_folded_scalarstring(self, data: Any) -> Any: ...
    def represent_single_quoted_scalarstring(self, data: Any) -> Any: ...
    def represent_double_quoted_scalarstring(self, data: Any) -> Any: ...
    def represent_plain_scalarstring(self, data: Any) -> Any: ...
    def insert_underscore(
        self, prefix: Any, s: Any, underscore: Any, anchor: Any = ...
    ) -> Any: ...
    def represent_scalar_int(self, data: Any) -> Any: ...
    def represent_binary_int(self, data: Any) -> Any: ...
    def represent_octal_int(self, data: Any) -> Any: ...
    def represent_hex_int(self, data: Any) -> Any: ...
    def represent_hex_caps_int(self, data: Any) -> Any: ...
    def represent_scalar_float(self, data: Any) -> Any: ...
    def represent_sequence(
        self, tag: Any, sequence: Any, flow_style: Any = ...
    ) -> Any: ...
    def merge_comments(self, node: Any, comments: Any) -> Any: ...
    alias_key: Incomplete
    def represent_key(self, data: Any) -> Any: ...
    def represent_mapping(
        self, tag: Any, mapping: Any, flow_style: Any = ...
    ) -> Any: ...
    def represent_omap(self, tag: Any, omap: Any, flow_style: Any = ...) -> Any: ...
    def represent_set(self, setting: Any) -> Any: ...
    def represent_dict(self, data: Any) -> Any: ...
    def represent_list(self, data: Any) -> Any: ...
    def represent_datetime(self, data: Any) -> Any: ...
    def represent_tagged_scalar(self, data: Any) -> Any: ...
    def represent_scalar_bool(self, data: Any) -> Any: ...
